package cn.net.cpzslibs.prot.handset.newProt;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.req.Prot20018ReqBean;
import cn.net.cpzslibs.prot.handset.bean.res.Prot20018ResBean;
import cn.net.cpzslibs.prot.utils.StrUtils;

/** 
 * @author  作者 李扬: 
 * @date 创建时间：2017-4-20 下午1:38:08 
 * @version 1.0 
 * @parameter 
 * @since  
 * @return  
 */
public class Prot20018LabelOption extends ProtBase {

	/**
	 * 是否成功
	 */
	private short iResult;
	
	private final short iTaskCode20018 = 20018;
	private Gson gson;
	private Prot20018ResBean resBean;
	
	public Prot20018LabelOption() {
		gson = new Gson();
	}
	public Prot20018ResBean getResBean(){
		return this.resBean;
	}
	
	public void reqLabelOption(SocketCreate create, Prot20018ReqBean reqBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), reqBean);
	}
	
	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot20018ReqBean reqBean)
			throws IOException {
		if (socket.isConnected()) {
			if (!socket.isOutputShutdown()) {
				//发送登录信息
				debugLog(iTaskCode20018, "开始请求产品列表");
				sendProt(dos, reqBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLabelOption(dis);
			}
		}
	}
	
	/**
	 * 读取JSon数据
	 * @param dis
	 * @throws IOException
	 */
	private void recLabelOption(DataInputStream dis) throws IOException {
		debugLog(iTaskCode20018, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode20018, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			resBean = gson.fromJson(jsonData, Prot20018ResBean.class);
		}	
		System.err.println("resBean: " + resBean.toString());	
		recCheckCode(dis);
	}
	
	
	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot20018ReqBean reqBean) throws IOException {
		String bodyContent = gson.toJson(reqBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode20018, bodySize);
		dos.write(bodyContent.getBytes("UTF-8"));
		sendCheckCoded(dos,bodyContent.getBytes("UTF-8"));
	}
	


}
